#![recursion_limit = "1024"]

extern crate console_error_panic_hook;
extern crate js_sys;

use std::panic;
use wasm_bindgen::prelude::*;
use yew::prelude::*;
use weblog::*;

mod agents;
mod components;
mod utils;

#[wasm_bindgen(module = "/static/player.js")]
extern "C" {
    fn get_val() -> i32;
}

#[wasm_bindgen(start)]
pub fn run_app() {
    #[cfg(debug_assertions)]
    panic::set_hook(Box::new(console_error_panic_hook::hook));

    console_log!("Get value from player module:", get_val());

    App::<components::App>::new().mount_to_body();
}
